// If you want to use any or all of the code, be my guest.
// If you want to midify the code, be my guest.
// Have fun, hope you understand it, and don't rag me for the lameness
// of the coding, it works !
//
// Dave
// Shadowsoft Inc.
// 905-875-2519 it's your dime, call me if you want to chat.
// 905-878-2000 (fax) I only guarantee a response if you call me in person
// CIS 76056,1537


/*
These are the keyboard scan codes
These refer to the keys themselves. You must check for all special cases
such as 'shift' 'caps lock' etc. yourself.

ESC		1
! or 1          2
@ or 2		3
# or 3		4
$ or 4 		5
% or 5		6
^ or 6		7
& or 7		8
* or 8		9
( or 9		10
) or 0		11
_ or -		12
+ or =		13
bksp		14
tab		15
Q		16
W		17
E		18
R		19
T		20
Y		21
U		22
I		23
O		24
P		25
{ or [		26
} or ]		27
enter		28
ctrl		29

A		30
S		31
D		32
F		33
G		34
H		35
J		36
K		37
L		38
: or ;		39
" or '		40
~ or `		41
lft shift	42
| or \		43
Z		44
X		45
C		46
V		47
B		48
N		49
M		50
< or ,		51
> or .		52
? or /		53
rgt shift	54
prt scr or *	55
alt		56
spacebar	57

caps lock	58
f1		59
f2		60
f3		61
f4		62
f5		63
f6		64
f7		65
f8		66
f9		67
f10		68
f11		133
f12		134
num lock	69
scroll lock	70
home or 7	71
up or 8		72
pgup or 9	73
gray -		74
left or 4	75
center or 5	76
right or 6	77
gray +		78
end or 1	79
down or 2	80
pgdn or 3	81
ins or 0	82
del or .	83
*/


// This is the C++ code fore the keyboard driver.
// Actually, very little of my routine is C++ code.
// Sorry, hope that's not a big problem

	unsigned char	keybuf[128];

extern "C" void	initkeyboard(void);
extern "C" void	resetkeyboard(void);


	void	main(void)
{
	initkeyboard();
	dataseg = _DS;

	if(keybuf[1] != 0)
		{
		//do your stuff here
		}

	resetkeyboard();
}


// And here is the assembly code.
// can it be written for in-line assembly, I'm not sure.
// If anyone can tell me why when certain combinations of keys are held
// that other keys are locked out, it would be greatly appreciated.

extrn	_keybuf:byte
extrn	_dataseg:word
oldkeyseg	dw	0
oldkeyoff	dd	0



	PUBLIC	_initkeyboard
_initkeyboard	PROC
	push	eax
	push	ebx
	push	ecx
	push	edx

	mov	ax,0204h
	mov	bl,09h
	int	31h
	mov     oldkeyseg,cx
	mov	oldkeyoff,edx

	mov	ax,0205h
	mov	bl,09h
	mov	edx,offset keyboardroutine
	mov	cx,cs

	int	31h

	pop	edx
	pop	ecx
	pop	ebx
	pop	eax

	ret
_initkeyboard	ENDP

	PUBLIC	_resetkeyboard
_resetkeyboard	PROC
	push	eax
	push	ebx
	push	ecx
	push	edx

	mov	ax,0205h
	mov	bl,09h
	mov	edx,oldkeyoff
	mov	cx,oldkeyseg

	int	31h

	pop	edx
	pop	ecx
	pop	ebx
	pop	eax
	ret
_resetkeyboard	ENDP


keyboardroutine:
	push	eax
	push	ebx
	push	ecx
	push	edx

	mov	ebx,offset _keybuf
	mov	eax,0

	in	al,60h
	mov	ah,0

	cmp	al,128
	jnb	kbr1	;release key

	add	ebx,eax
	mov	cl,1

	push	ds
	mov	ds,cs:[_dataseg]
	mov	[ebx],cl
	pop	ds
	jmp	kbr2
kbr1:
	and	al,127
	add	ebx,eax
	mov	cl,0

	push	ds
	mov	ds,cs:[_dataseg]
	mov	[ebx],cl
	pop	ds
kbr2:
	in	al,61h
	mov	ah,al
	or	al,80h
	out	61h,al
	mov	al,20h
	out	20h,al

	pop	edx
	pop	ecx
	pop	ebx
	pop	eax
	iret
